Index: roard/include/req.h
===================================================================
--- roard/include/req.h	(revision 6052)
+++ roard/include/req.h	(revision 0)
@@ -1,26 +1,3 @@
 //req.h:
-
-/*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2015
- *
- *  This file is part of roard a part of RoarAudio,
- *  a cross-platform sound system for both, home and professional use.
- *  See README for details.
- *
- *  This file is free software; you can redistribute it and/or modify
- *  it under the terms of the GNU General Public License version 3
- *  as published by the Free Software Foundation.
- *
- *  RoarAudio is distributed in the hope that it will be useful,
- *  but WITHOUT ANY WARRANTY; without even the implied warranty of
- *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *  GNU General Public License for more details.
- *
- *  You should have received a copy of the GNU General Public License
- *  along with this software; see the file COPYING.  If not, write to
- *  the Free Software Foundation, 51 Franklin Street, Fifth Floor,
- *  Boston, MA 02110-1301, USA.
- *
- */
 
 #ifndef _REQ_H_
@@ -29,57 +6,33 @@
 #include <roaraudio.h>
 
-int req_on_noop        (int client, struct roar_message * mes, char ** data, uint32_t flags[2]);
-int req_on_quit        (int client, struct roar_message * mes, char ** data, uint32_t flags[2]);
+int req_on_noop        (int client, struct roar_message * mes, char * data);
 
-int req_on_identify    (int client, struct roar_message * mes, char ** data, uint32_t flags[2]);
-int req_on_auth        (int client, struct roar_message * mes, char ** data, uint32_t flags[2]);
+int req_on_identify    (int client, struct roar_message * mes, char * data);
+int req_on_auth        (int client, struct roar_message * mes, char * data);
 
-int req_on_whoami      (int client, struct roar_message * mes, char ** data, uint32_t flags[2]);
+int req_on_new_stream  (int client, struct roar_message * mes, char * data);
+int req_on_exec_stream (int client, struct roar_message * mes, char * data);
 
-int req_on_new_stream  (int client, struct roar_message * mes, char ** data, uint32_t flags[2]);
-int req_on_exec_stream (int client, struct roar_message * mes, char ** data, uint32_t flags[2]);
-int req_on_con_stream  (int client, struct roar_message * mes, char ** data, uint32_t flags[2]);
-int req_on_passfh      (int client, struct roar_message * mes, char ** data, uint32_t flags[2]);
+int req_on_set_meta    (int client, struct roar_message * mes, char * data);
 
-#ifdef ROAR_SUPPORT_META
-int req_on_set_meta    (int client, struct roar_message * mes, char ** data, uint32_t flags[2]);
-int req_on_get_meta    (int client, struct roar_message * mes, char ** data, uint32_t flags[2]);
-int req_on_list_meta   (int client, struct roar_message * mes, char ** data, uint32_t flags[2]);
-#endif
+int req_on_get_standby (int client, struct roar_message * mes, char * data);
+int req_on_set_standby (int client, struct roar_message * mes, char * data);
 
-int req_on_get_standby (int client, struct roar_message * mes, char ** data, uint32_t flags[2]);
-int req_on_set_standby (int client, struct roar_message * mes, char ** data, uint32_t flags[2]);
+int req_on_exit        (int client, struct roar_message * mes, char * data);
 
-int req_on_exit        (int client, struct roar_message * mes, char ** data, uint32_t flags[2]);
+int req_on_server_oinfo(int client, struct roar_message * mes, char * data);
 
-int req_on_gettimeofday(int client, struct roar_message * mes, char ** data, uint32_t flags[2]);
-int req_on_server_info (int client, struct roar_message * mes, char ** data, uint32_t flags[2]);
+int req_on_list_clients(int client, struct roar_message * mes, char * data);
+int req_on_list_streams(int client, struct roar_message * mes, char * data);
 
-int req_on_server_oinfo(int client, struct roar_message * mes, char ** data, uint32_t flags[2]);
+int req_on_get_client  (int client, struct roar_message * mes, char * data);
+int req_on_get_stream  (int client, struct roar_message * mes, char * data);
 
-int req_on_caps        (int client, struct roar_message * mes, char ** data, uint32_t flags[2]);
+int req_on_kick        (int client, struct roar_message * mes, char * data);
 
-int req_on_list_clients(int client, struct roar_message * mes, char ** data, uint32_t flags[2]);
-int req_on_list_streams(int client, struct roar_message * mes, char ** data, uint32_t flags[2]);
+int req_on_add_data    (int client, struct roar_message * mes, char * data);
 
-int req_on_get_client  (int client, struct roar_message * mes, char ** data, uint32_t flags[2]);
-int req_on_get_stream  (int client, struct roar_message * mes, char ** data, uint32_t flags[2]);
 
-int req_on_get_stream_para (int client, struct roar_message * mes, char ** data, uint32_t flags[2]);
-int req_on_set_stream_para (int client, struct roar_message * mes, char ** data, uint32_t flags[2]);
-
-int req_on_kick        (int client, struct roar_message * mes, char ** data, uint32_t flags[2]);
-int req_on_attach      (int client, struct roar_message * mes, char ** data, uint32_t flags[2]);
-
-int req_on_set_vol     (int client, struct roar_message * mes, char ** data, uint32_t flags[2]);
-int req_on_get_vol     (int client, struct roar_message * mes, char ** data, uint32_t flags[2]);
-
-int req_on_add_data    (int client, struct roar_message * mes, char ** data, uint32_t flags[2]);
-
-int req_on_beep        (int client, struct roar_message * mes, char ** data, uint32_t flags[2]);
-
-int req_on_wait        (int client, struct roar_message * mes, char ** data, uint32_t flags[2]);
-
-//int req_on_ (int client, struct roar_message * mes, char ** data, uint32_t flags[2]);
+//int req_on_ (int client, struct roar_message * mes, char * data);
 
 #endif
Index: roard/include/roard.h
===================================================================
--- roard/include/roard.h	(revision 6052)
+++ roard/include/roard.h	(revision 0)
@@ -1,117 +1,13 @@
 //roard.h:
-
-/*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2015
- *
- *  This file is part of roard a part of RoarAudio,
- *  a cross-platform sound system for both, home and professional use.
- *  See README for details.
- *
- *  This file is free software; you can redistribute it and/or modify
- *  it under the terms of the GNU General Public License version 3
- *  as published by the Free Software Foundation.
- *
- *  RoarAudio is distributed in the hope that it will be useful,
- *  but WITHOUT ANY WARRANTY; without even the implied warranty of
- *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *  GNU General Public License for more details.
- *
- *  You should have received a copy of the GNU General Public License
- *  along with this software; see the file COPYING.  If not, write to
- *  the Free Software Foundation, 51 Franklin Street, Fifth Floor,
- *  Boston, MA 02110-1301, USA.
- *
- */
 
 #ifndef _ROARD_H_
 #define _ROARD_H_
 
-// configure ROAR_INFO()
-extern int g_verbose;
-#define ROAR_DBG_INFOVAR g_verbose
-
-// configure ROAR_*()
-#define ROAR_DBG_PREFIX "roard"
-
-// need to include this first as we need the config
+#include <signal.h>
+#include <sys/select.h>
 #include <roaraudio.h>
-#include <roaraudio/units.h>
-#include <libroarlight/libroarlight.h>
-#include <libroareio/libroareio.h>
-
-#include <ctype.h>
-
-#ifdef ROAR_HAVE_H_SIGNAL
-#include <signal.h>
-#endif
-
-#if defined(ROAR_HAVE_SELECT) && defined(ROAR_HAVE_H_SYS_SELECT)
-#include <sys/select.h>
-#endif
-
-#ifdef ROAR_HAVE_WAIT
-#include <sys/wait.h>
-#endif
-
-#if !defined(ROAR_TARGET_WIN32) && !defined(ROAR_TARGET_MICROCONTROLLER)
-#include <grp.h>
-#include <pwd.h>
-#endif
-
-#ifdef ROAR_HAVE_H_SYS_TIME
-#include <sys/time.h>
-#endif
-#ifdef ROAR_HAVE_H_TIME
-#include <time.h>
-#endif
-
-#ifdef ROAR_HAVE_LIBSLP
-#include <slp.h>
-#endif
-
-/*
-#ifdef __linux__
-#include <linux/unistd.h>
-#include <linux/ioprio.h>
-#endif
-*/
-
-#define ROAR_SUBSYS_NONE          0x00
-#define ROAR_SUBSYS_WAVEFORM      0x01
-#define ROAR_SUBSYS_MIDI          0x02
-#define ROAR_SUBSYS_CB            0x04
-#define ROAR_SUBSYS_LIGHT         0x08
-#define ROAR_SUBSYS_RAW           0x10
-#define ROAR_SUBSYS_COMPLEX       0x20
-#define ROAR_SUBSYS_RDTCS         0x40
-
-// listeing code:
-#define ROAR_MAX_LISTEN_SOCKETS   16
-
-union uniinst {
- void * vp;
- int    si;
-};
-
-enum output_format {
- FORMAT_NATIVE = 1,
- FORMAT_WIKI,
- FORMAT_CSV,
-
- FORMAT_DEFAULT = FORMAT_NATIVE
-};
-
-
-// MFOI = Marked For Optional Include
-
 //#include "buffer.h"
-#include "caps.h"
-#include "memlock.h"
-#include "codecfilter.h" /* MFOI */
-#include "container_framework.h" /* MFOI */
-#include "rolestack.h"
 #include "client.h"
-#include "auth.h"
-#include "driver.h" /* MFOI */
+#include "driver.h"
 #include "output.h"
 #include "mixer.h"
@@ -121,117 +17,19 @@
 #include "commands.h"
 #include "req.h"
-#include "emul_simple.h" /* MFOI */
-#include "emul_rsound.h" /* MFOI */
 #include "sources.h"
-#include "sample.h"
-#include "hwmixer.h"
-#include "meta.h"
-#include "midi.h"
-#include "ssynth.h"
-#include "light.h"
-#include "raw.h"
-#include "rdtcs.h"
-#include "waveform.h"
-#include "beep.h"
-#include "lib.h"
-#include "plugins.h"
 
+int alive;
 
-extern int alive;
-#ifdef ROAR_SUPPORT_LISTEN
-extern int g_no_listen;
-#endif
+int g_standby;
 
-extern uint32_t g_pos; // current position in output stream
-
-extern int g_standby;
-extern int g_autostandby;
-
-#ifdef ROAR_SUPPORT_LISTEN
-struct roard_listen;
-#endif
-
-int main_loop (struct roar_audio_info * sa, int sysclocksync);
-void cleanup_listen_socket (int terminate);
+int main_loop (int driver, DRIVER_USERDATA_T driver_inst, struct roar_audio_info * sa);
 void clean_quit (void);
 void clean_quit_prep (void);
 
-void on_sig_int  (int signum);
-void on_sig_term (int signum);
-void on_sig_chld (int signum);
-void on_sig_usr1 (int signum);
+void on_sig_int (int signum);
 
-#ifdef ROAR_SUPPORT_LISTEN
-int get_listen(struct roard_listen ** sock, const char *** sockname);
-int add_listen (const char * addr, int port, int sock_type, char * user, char * group, int proto, int dir, struct roar_audio_info * info);
-#endif
+int g_listen_socket;
 
-#ifdef ROAR_SUPPORT_LISTEN
-extern struct roard_listen {
- int used;
- struct roar_vio_calls sock;
- int proto;
- union {
-  void * vp;
-  int    si;
-  struct {
-   int                    dir;
-   struct roar_audio_info info;
-  } stpl;
- } inst;
-} g_listen[ROAR_MAX_LISTEN_SOCKETS];
-#endif
-
-extern int g_self_client;
-
-extern int g_terminate;
-
-extern struct roar_audio_info * g_sa, * g_max_sa;
-
-#define CONF_DEF_STRING "***default***"
-
-extern struct roard_config {
- uint32_t flags;
- struct {
-  uint32_t                   flags;
-  struct roar_mixer_settings mixer;
-  int                        mixer_channels;
-  int                        rpgmode;
- } streams[ROAR_DIR_DIRIDS];
- char * location;
- char * description;
- char * contact;
- char * serial;
- char * uiurl;
- size_t jumbo_mtu;
- int memlock_level;
-#ifdef ROAR_HAVE_SYSTEM
- struct {
-  const char * post_shutdown;
- } scripts;
-#endif
-} * g_config;
-
-struct _counters {
- size_t clients, streams,
-        samples,
-        sources, outputs,
-        mixers, bridges,
-        listens;
-};
-
-extern struct counters {
- struct _counters cur, sum;
-} g_counters;
-
-
-#define counters_init() memset(counters_getptr(), 0, sizeof(struct counters))
-//#define counters_inc(c,i) do { signed long int __i = (i); if ( __i < 0 && __i > (g_counters.cur.c) ) { ROAR_WARN("counters_inc(c=%s, i=%li): Decrement request bigger than current counter value. Counter out of syn!", )  } while (0)
-#define counters_inc(c,i) do { signed long int __i = (i); counters_getptr()->cur.c += __i; if ( __i > 0 ) counters_getptr()->sum.c += __i; } while (0)
-
-#define counters_get(g,c) ((counters_getptr()->g.c))
-
-struct counters * counters_getptr(void);
-void counters_print(int type, int force);
+struct roar_audio_info * g_sa;
 
 #endif
Index: roard/include/sources.h
===================================================================
--- roard/include/sources.h	(revision 6052)
+++ roard/include/sources.h	(revision 0)
@@ -1,26 +1,3 @@
 //sources.h:
-
-/*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2015
- *
- *  This file is part of roard a part of RoarAudio,
- *  a cross-platform sound system for both, home and professional use.
- *  See README for details.
- *
- *  This file is free software; you can redistribute it and/or modify
- *  it under the terms of the GNU General Public License version 3
- *  as published by the Free Software Foundation.
- *
- *  RoarAudio is distributed in the hope that it will be useful,
- *  but WITHOUT ANY WARRANTY; without even the implied warranty of
- *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *  GNU General Public License for more details.
- *
- *  You should have received a copy of the GNU General Public License
- *  along with this software; see the file COPYING.  If not, write to
- *  the Free Software Foundation, 51 Franklin Street, Fifth Floor,
- *  Boston, MA 02110-1301, USA.
- *
- */
 
 #ifndef _SOURCES_H_
@@ -29,41 +6,10 @@
 #include <roaraudio.h>
 
-#ifndef ROAR_WITHOUT_DCOMP_SOURCES
-#define SRC_FLAG_NONE           0x00
-#define SRC_FLAG_FHSEC          0x01
-
-struct roar_source {
- char * name;
- char * desc;
- char * devices;
- unsigned int flags;
- unsigned int subsystems;
- int (*old_open)(const char * driver, const char * device, const char * container, const char * options, int primary);
- int (*new_open)(int stream   , const char * device, int fh, const char * driver);
-};
+int g_source_client;
 
 int sources_init (void);
 int sources_free (void);
 
-int sources_set_client (int client);
-
-void print_sourcelist (void);
-
-int sources_add (char * driver, char * device, char * container, char * options, int primary);
-
-int sources_add_new (struct roar_source * source,
-                     char * driver, char * device,
-                     char * options, int primary);
-
-int sources_add_dstr (int stream   , const char * device, int fh, const char * driver);
-int sources_add_cf   (const char * driver, const char * device, const char * container, const char * options, int primary);
-
-int sources_add_roar (int stream, const char * device, int fh, const char * driver);
-int sources_add_radionoise (int stream, const char * device, int fh, const char * driver);
-
-#ifndef ROAR_WITHOUT_DCOMP_CDRIVER
-int sources_add_cdriver (int stream   , const char * device, int fh, const char * driver);
-#endif
-#endif
+int sources_add (char * driver, char * device, char * containe, char * options, int primary);
 
 #endif
Index: roard/include/streams.h
===================================================================
--- roard/include/streams.h	(revision 6052)
+++ roard/include/streams.h	(revision 0)
@@ -1,26 +1,3 @@
 //streams.h:
-
-/*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2015
- *
- *  This file is part of roard a part of RoarAudio,
- *  a cross-platform sound system for both, home and professional use.
- *  See README for details.
- *
- *  This file is free software; you can redistribute it and/or modify
- *  it under the terms of the GNU General Public License version 3
- *  as published by the Free Software Foundation.
- *
- *  RoarAudio is distributed in the hope that it will be useful,
- *  but WITHOUT ANY WARRANTY; without even the implied warranty of
- *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *  GNU General Public License for more details.
- *
- *  You should have received a copy of the GNU General Public License
- *  along with this software; see the file COPYING.  If not, write to
- *  the Free Software Foundation, 51 Franklin Street, Fifth Floor,
- *  Boston, MA 02110-1301, USA.
- *
- */
 
 #ifndef _STREAMS_H_
@@ -35,44 +12,7 @@
 */
 
-//#define ROAR_STREAM(x)        ((struct roar_stream*)(x))
 #define ROAR_STREAM_SERVER(x) ((struct roar_stream_server*)(x))
 
-// stream ctls...:
-
-#define ROAR_STREAM_CTL_COMPMASK  0xFF000000
-#define ROAR_STREAM_CTL_TYPEMASK  0x00FF0000
-#define ROAR_STREAM_CTL_CMDMASK   0x0000FFFF
-
-#define ROAR_STREAM_CTL_COMP_BASE 0x00000000
-#define ROAR_STREAM_CTL_COMP_CF   0x01000000
-#define ROAR_STREAM_CTL_COMP_DRV  0x02000000
-
-#define ROAR_STREAM_CTL_TYPE_VOID   0x00000000
-#define ROAR_STREAM_CTL_TYPE_INT    0x00010000
-#define ROAR_STREAM_CTL_TYPE_FLOAT  0x00020000
-#define ROAR_STREAM_CTL_TYPE_FPI100 0x00030000 /* fix point integter int/100 */
-
-#define STREAM_DIR_NONE             0x00
-#define STREAM_DIR_IN               0x01
-#define STREAM_DIR_OUT              0x02
-#define STREAM_DIR_BIDIR            (STREAM_DIR_IN|STREAM_DIR_OUT)
-
-#define MAX_LTM_WINDOWS_PER_STREAM  1
-
-struct roar_ltm_vals {
- int64_t rms;
-};
-
-struct roar_stream_ltm {
- int window;
- int parent_window;
- int mt;
- size_t refc;
- size_t channels;
- struct roar_ltm_vals *  cur;
- struct roar_ltm_vals ** history;
-};
-
-extern struct roar_stream_server {
+struct roar_stream_server {
  struct roar_stream _stream;
  unsigned int pos_abs;
@@ -81,45 +21,5 @@
  size_t need_extra;
  void  * output;
- struct roar_mixer_settings mixer;
-#ifdef ROAR_SUPPORT_META
- struct roar_meta meta[ROAR_META_MAX_PER_STREAM];
-#endif
- int is_new;
- int codecfilter;
- ROAR_AUDIO_INFO_TYPE codec_orgi;
- CODECFILTER_USERDATA_T codecfilter_inst;
- int socktype;
- int pre_underruns;
- int post_underruns;
- struct roar_vio_calls vio;
- int primary;
- int driver_id;
-// struct roardsp_filterchain fc;
- uint32_t flags;
- uint32_t flags_protection;
- uint_least32_t delay;
- char * name;
- int ready;
- struct roar_buffer * outputbuffer;
- int state;
- struct roar_buffer * prethru;
- struct roar_vio_calls jumbo;
- struct roar_vio_calls * viop;
- int mixer_stream;
- struct roardsp_chanmap chanmap;
- int role;
- int parent_stream;
- struct roar_stream_ltm ltm[MAX_LTM_WINDOWS_PER_STREAM];
-#ifndef ROAR_WITHOUT_DCOMP_MIXER
- struct hwmixer_stream * mixerstream;
-#endif
- size_t single_sink_c;
- size_t single_sink_self_c;
- int rpgmode;
 } * g_streams[ROAR_STREAMS_MAX];
-
-extern int streams_recsource_id;
-
-void streams_change_sync_num(int id, int diff);
 
 int streams_init   (void);
@@ -130,79 +30,15 @@
 
 int streams_set_client (int id, int client);
-int streams_get_client (int id);
-
-int streams_set_dir    (int id, int dir, int defaults);
-int streams_get_dir    (int id);
-
-int streams_set_mixer_stream(int id, int mixer);
-int streams_get_mixer_stream(int id);
-
-int streams_set_role   (int id, int role);
-
-int streams_dir2subsys (int dir);
-int streams_get_subsys (int id);
-int streams_get_ssdir  (int id);
-
-int streams_new_virtual (int parent, struct roar_stream_server ** stream);
 
 int streams_set_fh     (int id, int fh);
-int streams_get_fh     (int id);
-int streams_set_null_io(int id);
 int streams_get        (int id, struct roar_stream_server ** stream);
-int streams_get_clientobj (int id, struct roar_stream        ** stream);
 
-int streams_set_socktype (int id, int socktype);
-int streams_get_socktype (int id);
-
-int streams_is_ready     (int id);
-int streams_is_new       (int id);
-
-int streams_set_primary  (int id, int prim);
-int streams_mark_primary (int id);
-int streams_set_sync     (int id, int sync);
-int streams_set_mmap     (int id, int reset);
-int streams_set_single_sink(int id, int reset);
-int streams_set_flag     (int id, uint32_t flag);
-int streams_set_rawflag  (int id, uint32_t flag);
-int streams_reset_flag   (int id, uint32_t flag);
-int streams_get_flag     (int id, uint32_t flag);
-
-int streams_protect_flag (int id, uint32_t flag);
-
-int streams_set_name     (int id, char * name);
-char * streams_get_name  (int id);
-
-int streams_calc_delay   (int id);
-int streams_set_mixer    (int id);
-
-int streams_set_map      (int id, char * map, size_t len);
-
-int streams_get_rpg      (int id, struct roar_stream_rpg * rpg);
-int streams_set_rpg      (int id, const struct roar_stream_rpg * rpg);
-
-int streams_ltm_ctl      (int id, int mt, int window, int cmd);
-int streams_ltm_calc     (int id, struct roar_audio_info * info, void * data, size_t len);
-struct roar_stream_ltm * streams_ltm_get(int id, int mt, int window);
-
-struct hwmixer_stream * streams_get_mixerstream(int id);
-int streams_set_mixerstream(int id, struct hwmixer_stream * mstream);
-int streams_read_mixervalues(int id);
-
-int streams_ctl          (int id, int_least32_t cmd, void * data);
-
-int stream_add_buffer     (int id, struct roar_buffer **  buf);
-int stream_shift_out_buffer   (int id, void * data, size_t * len);
-
-int stream_outputbuffer_request(int id, struct roar_buffer ** buf, size_t len);
-int stream_outputbuffer_destroy(int id);
-
-int stream_prethru_add(int id, struct roar_buffer ** buf);
-int stream_prethru_add_data(int id, void ** buf, size_t len);
-int stream_prethru_destroy(int id);
-int stream_prethru_send(int dst, int src);
+int stream_add_buffer     (int id, struct roar_buffer *  buf);
+//int stream_get_buffer     (int id, struct roar_buffer ** buf);
+int stream_shift_buffer   (int id, struct roar_buffer ** buf);
+int stream_unshift_buffer (int id, struct roar_buffer *  buf);
 
 int streams_check      (int id);
 int streams_send_mon   (int id);
-int streams_send_filter_all(void);
 int streams_send_filter(int id);
 
@@ -210,12 +46,5 @@
 int streams_get_outputbuffer (int id, void ** buffer, size_t size);
 int streams_fill_mixbuffer   (int id, struct roar_audio_info * info);
-int streams_fill_mixbuffer2  (int id, struct roar_audio_info * info);
 
-ssize_t stream_vio_read (int stream, void         * buf, size_t count);
-ssize_t stream_vio_write(int stream, void         * buf, size_t count);
-int     stream_vio_ctl  (int stream, roar_vio_ctl_t cmd, void * data);
-ssize_t stream_vio_s_read (struct roar_stream_server * stream, void         * buf, size_t count);
-ssize_t stream_vio_s_write(struct roar_stream_server * stream, void         * buf, size_t count);
-int     stream_vio_s_ctl  (struct roar_stream_server * stream, roar_vio_ctl_t cmd, void * data);
 
 #endif
Index: roard/loop.c
===================================================================
--- roard/loop.c	(revision 6052)
+++ roard/loop.c	(revision 0)
@@ -1,118 +1,31 @@
 //loop.c:
-
-/*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2015
- *
- *  This file is part of roard a part of RoarAudio,
- *  a cross-platform sound system for both, home and professional use.
- *  See README for details.
- *
- *  This file is free software; you can redistribute it and/or modify
- *  it under the terms of the GNU General Public License version 3
- *  as published by the Free Software Foundation.
- *
- *  RoarAudio is distributed in the hope that it will be useful,
- *  but WITHOUT ANY WARRANTY; without even the implied warranty of
- *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *  GNU General Public License for more details.
- *
- *  You should have received a copy of the GNU General Public License
- *  along with this software; see the file COPYING.  If not, write to
- *  the Free Software Foundation, 51 Franklin Street, Fifth Floor,
- *  Boston, MA 02110-1301, USA.
- *
- */
 
 #include "roard.h"
 
-int main_loop (struct roar_audio_info * sa, int sysclocksync) {
+int main_loop (int driver, DRIVER_USERDATA_T driver_inst, struct roar_audio_info * sa) {
  void ** streams_input = NULL;
- int     term = 0;
- int     streams;
-#ifdef ROAR_HAVE_GETTIMEOFDAY
- long int loopc = 0;
- struct timeval         try, ans;
- float  freq;
-#endif
-#ifdef ROAR_SUPPORT_LISTEN
- int i;
- int have_listen;
-#endif
-#ifdef MONITOR_LATENCY
- long int ans_1last = 0, ans_2last = 0, ans_3last = 0;
-
- printf("\n\e[s");
- fflush(stdout);
-#endif
+ uint32_t pos = 0;
 
  ROAR_DBG("main_loop(*) = ?");
-// alive = 1;
- g_pos = 0;
-
-#ifdef ROAR_HAVE_GETTIMEOFDAY
- if ( sysclocksync ) {
-  gettimeofday(&try, NULL);
- }
-#endif
+ alive = 1;
 
  while (alive) {
-#if defined(MONITOR_LATENCY) && defined(ROAR_HAVE_GETTIMEOFDAY)
-  gettimeofday(&try, NULL);
-#endif
-
   ROAR_DBG("main_loop(*): looping...");
 
-  roar_watchdog_trigger();
-
-#ifdef ROAR_SUPPORT_LISTEN
-  have_listen = 0;
-  for (i = 0; i < ROAR_MAX_LISTEN_SOCKETS; i++) {
-   if ( g_listen[i].used ) {
-    have_listen = 1;
-    break;
-   }
-  }
-
-  if ( have_listen ) {
-   ROAR_DBG("main_loop(*): check for new clients...");
-   net_check_listen();
-  }
-#endif
+  ROAR_DBG("main_loop(*): check for new clients...");
+  net_check_listen();
 
   ROAR_DBG("main_loop(*): check for new data...");
-#ifdef ROAR_SUPPORT_LISTEN
-  if ( clients_check_all() == 0 && g_terminate && !have_listen ) {
-#else
-  if ( clients_check_all() == 0 && g_terminate ) {
-#endif
-   term  = 1;
-  }
-
-#ifndef ROAR_WITHOUT_DCOMP_MIDI
-  ROAR_DBG("main_loop(*): updating midi subsystem...");
-  midi_update();
-#endif
-#ifndef ROAR_WITHOUT_DCOMP_LIGHT
-  light_update();
-#endif
-
-  if ( waveform_update_inputs() == -1 )
-   alive = 0;
+  clients_check_all();
 
   ROAR_DBG("main_loop(*): mixing clients...");
   if ( g_standby ) {
    // while in standby we still neet to get the buffers to free input buffer space.
-   streams = streams_get_mixbuffers(&streams_input, sa, g_pos);
+   streams_get_mixbuffers(&streams_input, sa, pos);
   } else {
-   if ( ( streams = streams_get_mixbuffers(&streams_input, sa, g_pos)) != -1 ) {
-    roar_mix_pcm(g_output_buffer, sa->bits, streams_input, ROAR_OUTPUT_BUFFER_SAMPLES * sa->channels);
+   if ( streams_get_mixbuffers(&streams_input, sa, pos) == 0 ) {
+    mix_clients(g_output_buffer, sa->bits, streams_input, ROAR_OUTPUT_BUFFER_SAMPLES * sa->channels);
    }
   }
-
-  if ( term && streams < 1 )
-   alive = 0;
-
-  if ( waveform_update_mixer() == -1 )
-   alive = 0;
 
 /*
@@ -121,77 +34,15 @@
 */
 
-  if ( plugins_update() == -1 )
-   alive = 0;
-
-  ROAR_DBG("main_loop(*): sending output data...");
-
-#ifdef ROAR_HAVE_USLEEP
-  if ( g_standby || (streams < 1 && g_autostandby) ) {
-   roar_usleep(((uint_least32_t)1000000 * ROAR_OUTPUT_BUFFER_SAMPLES) / sa->rate);
-   ROAR_DBG("usleep(%u) = ?\n", (1000000 * ROAR_OUTPUT_BUFFER_SAMPLES) / sa->rate);
+  if ( g_standby ) {
+   usleep((1000000 * ROAR_OUTPUT_BUFFER_SAMPLES) / sa->rate);
   } else {
-#endif
-   clients_send_filter(sa);
-//   streams_send_filter_all(); // this currently results in deadlocks.
-   clients_send_mon(sa);
-#ifdef ROAR_HAVE_USLEEP
+   clients_send_filter(sa, pos);
+   output_buffer_flush(driver_inst, driver);
+   clients_send_mon(sa, pos);
   }
-#endif
-
-#ifndef ROAR_WITHOUT_DCOMP_MIDI
-  midi_reinit();
-#endif
-#ifndef ROAR_WITHOUT_DCOMP_SSYNTH
-  ssynth_update();
-#endif
-#ifndef ROAR_WITHOUT_DCOMP_LIGHT
-  light_reinit();
-#endif
-
 //  output_buffer_reinit();
 
-  g_pos = ROAR_MATH_OVERFLOW_ADD(g_pos, ROAR_OUTPUT_BUFFER_SAMPLES*g_sa->channels);
-  ROAR_DBG("main_loop(*): current pos: %u", g_pos);
-#if defined(MONITOR_LATENCY) && defined(ROAR_HAVE_GETTIMEOFDAY)
-  gettimeofday(&ans, NULL);
-
-  while (ans.tv_sec > try.tv_sec) {
-   ans.tv_sec--;
-   ans.tv_usec += 1000000;
-  }
-  ans.tv_usec -= try.tv_usec;
-
-  if ( loopc % 128 ) {
-   printf("\e[ucurrent latency: %.3fms  average: %.3fms   ",  ans.tv_usec                               / (double)1000,
-                                                             (ans.tv_usec+ans_3last+ans_2last+ans_1last)/ (double)4000);
-   fflush(stdout);
-  }
-
-  ans_3last = ans_2last;
-  ans_2last = ans_1last;
-  ans_1last = ans.tv_usec;
-#endif
-
-#ifdef ROAR_HAVE_GETTIMEOFDAY
-  if ( sysclocksync && !(loopc % sysclocksync) ) {
-   gettimeofday(&ans, NULL);
-
-   while (ans.tv_sec > try.tv_sec) {
-    ans.tv_sec--;
-    ans.tv_usec += 1000000;
-   }
-   ans.tv_usec -= try.tv_usec;
-
-
-   freq = (sysclocksync * ROAR_OUTPUT_BUFFER_SAMPLES) / (ans.tv_usec / 1e6);
-   printf("SYNC: f_conf=%iHz, f_real=%.2fHz diff=%+.3f%%\n", sa->rate, freq, 100*(freq/sa->rate - 1));
-
-//   memcpy(&try, &ans, sizeof(try));
-   gettimeofday(&try, NULL);
-  }
-
-  if ( sysclocksync )
-   loopc++;
-#endif
+  pos = ROAR_MATH_OVERFLOW_ADD(pos, ROAR_OUTPUT_BUFFER_SAMPLES);
+  ROAR_DBG("main_loop(*): current pos: %u", pos);
  }
 
